import { adminCredentials } from '~/components/credentials';
import { get } from './get';
import { getUrl } from './get-url';
import { headersWithAuth } from './headers-with-auth';

export const put = async (id: string, content: any, isNew: boolean = false) => {
  const credentials = adminCredentials();
  if (!credentials) {
    return null;
  }
  const { database } = credentials;

  if (!isNew) {
    const previous = await get(id);
    content._rev = previous._rev;
  }

  const headers = headersWithAuth();
  if (!headers) {
    return null;
  }
  headers.set('Content-type', 'application/json; charset=UTF-8');

  const response = await fetch(getUrl(id), {
    method: 'PUT',
    mode: 'cors',
    headers,
    body: JSON.stringify(content),
  });

  return await response.json();
};
